WITH Text_IO, Ada.Integer_Text_IO, Ada.Float_Text_IO;
USE  Text_IO, Ada.Integer_Text_IO, Ada.Float_Text_IO;
WITH Ada.Numerics.Discrete_Random;
WITH FctUniQuant;
USE FctUniQuant;
WITH FctUniQual;
USE FctUniQual;
WITH Fctbivqualquant;
USE Fctbivqualquant;
WITH Fctbivqualqual;
USE Fctbivqualqual;

PROCEDURE ProjetAnalyse IS
	
	function nbAleatoire( max : integer) return integer is
		subtype gen_range is integer range 0..max;
		
		PACKAGE NombreAleatoire IS NEW Ada.Numerics.Discrete_Random (
         gen_range);
    	USE NombreAleatoire;
	    
		G : Generator;
	begin
		reset(g);
		return integer( random(g));
	end nbAleatoire;

   --DEBUT declaration des besoins pour un test d'analyse quantitative

   Notes_Info    : QUANTITE;
   Analyse_Notes : ANA_QUANT;
   Res           : RES_ANA_QUANT;
   I             : Integer;


   --FIN jeu de la dclaration
   --DEBUT declaration des besoins pour un test d'analyse qualitative
   Options_Eisti   : QUALITE;
   Analyse_Options : ANA_QUAL;
   Res2            : RES_ANA_QUAL;
   Tmp             : Integer;

   --FIN de la declaration
   --DEBUT declaration des besoins pour un test d'analyse qualitativeXquantitative
   -- On rutilise la Ql et la Qt dj cre.
   Analyse_Options_Notes : ANA_QUAL_X_QUANT;
   Res3                  : RES_ANA_QUAL_X_QUANT;

   --FIN de la declaration
   --DEBUT declaration des besoins pour un test d'analyse qualitativeXqualitative
   -- On rutilise la qualite deja cree
   Origine_Scolaire        : QUALITE;
   Donnees                 : T_DOUBLET_QUAL_X_QUAL;
   Analyse_Options_Origine : ANA_QUAL_X_QUAL;
   Ligne,
   Colonne                 : Integer;
   Res4                    : RES_ANA_QUAL_X_QUAL;
   --FIN
BEGIN
	
   --DEBUT remplissage des champs pour les notes
   Notes_Info.Nom_Quantite :=
      "Resultats du contrle d'informatique              ";
   Notes_Info.Valeur_Min := 0.0;
   Notes_Info.Valeur_Max := 20.0;

--      Analyse_Notes.Quant := Notes_Info;
--      Analyse_Notes.Nb_Elements := 500;
--      FOR I IN 1 .. 500 LOOP
--         DELAY(0.001);
--         Reset(G);
--         Analyse_Notes.Donnees(I) := Float(Random(G));
--      END LOOP;
--   
--      FOR I IN 1 .. 500 LOOP
--         Put("L'etudiant ");
--         Put(I);
--         Put(" a eu ");
--         Put(Analyse_Notes.Donnees(I),2,1,0);
--         New_Line;
--      END LOOP;
   --FIN remplissage des champs des notes



   --DEBUT remplissage des champs pour l'origine scolaire
   Origine_Scolaire.Nom_Qualite :=
      "Resultats des origines scolaires des etudiants    ";
   Origine_Scolaire.Nombre_Etats_Possibles := 4;
   Origine_Scolaire.Etats_Possibles(1) :=
      "CPGE                                              ";
   Origine_Scolaire.Etats_Possibles(2) :=
      "CPI                                               ";
   Origine_Scolaire.Etats_Possibles(3) :=
      "FAC                                               ";
   Origine_Scolaire.Etats_Possibles(4) :=
      "IUT                                               ";

   --FIN remplissage des champs l'origine



   --DEBUT remplissage des champs pour les options

   Options_Eisti.Nom_Qualite :=
      "Resultat des options du cycle ingenieur           ";
   Options_Eisti.Nombre_Etats_Possibles := 3;
   Options_Eisti.Etats_Possibles(1) :=
      "IFI                                               ";
   Options_Eisti.Etats_Possibles(2) :=
      "DSI                                               ";
   Options_Eisti.Etats_Possibles(3) :=
      "LOL                                               ";


   Analyse_Options.Qual := Options_Eisti;
   Analyse_Options.Nb_Elements := 500;

   FOR I IN 1 .. 500 LOOP
      tmp := NbAleatoire(2);
      Analyse_Options.Donnees(I) := Options_Eisti.Etats_Possibles(Tmp+1);
   END LOOP;

   --FIN remplissage des champs pour les options

   --DEBUT remplissage des champs pour la partie QlQt

   --   Analyse_Options_Notes.Qual := Options_Eisti;
   --   Analyse_Options_Notes.Quant := Notes_Info;
   --   Analyse_Options_Notes.Nb_Elements := 500;

   --   FOR I IN 1 .. 500 LOOP
   --      Analyse_Options_Notes.Donnees(I).Val_Qual :=
   --         Options_Eisti.Etats_Possibles(NbAleatoire(2)+1);
   --      Analyse_Options_Notes.Donnees(I).Val_Quant := Float(NbAleatoire(20));
   --   END LOOP;

   --   FOR I IN 1 .. Analyse_Options_Notes.Nb_Elements LOOP
   --      Put("L'etudiant ");
   --      Put(I);
   --      Put(" a eu ");
   --      Put(Analyse_Options_Notes.Donnees(I).Val_Quant,0,0,0);
   --      Put(" a son ctrl d'info et a choisi l'option ");
   --      Put(Analyse_Options_Notes.Donnees(I).Val_Qual);
   --      New_Line;

   --   END LOOP;
   --FIN


   --DEBUT remplissage des champs pour la partie QlQl

   Analyse_Options_Origine.Qual2 := Options_Eisti;
   Analyse_Options_Origine.Qual1 := Origine_Scolaire;
   Analyse_Options_Origine.Nb_Elements := 5000;

   FOR I IN 1 .. 5000 LOOP
      Colonne := NbAleatoire(2)+1;
      Ligne := NbAleatoire(3)+1;
      Donnees(I).Val_Qual1 := Options_Eisti.Etats_Possibles(Ligne);
      Donnees(I).Val_Qual2 := Origine_Scolaire.Etats_Possibles(Colonne);
      Analyse_Options_Origine.Donnees(Ligne,Colonne) :=
         Analyse_Options_Origine.Donnees(Ligne,Colonne) + 1;
   END LOOP;

   FOR I IN 1 .. Analyse_Options_Origine.Nb_Elements LOOP
      Put("L'etudiant ");
      Put(I);
      Put(" vient de ");
      Put(Donnees(I).Val_Qual1);
      Put(" a choisi l'option ");
      Put(Donnees(I).Val_Qual2);
      New_Line;
   END LOOP;
   --FIN


   --   Res := TraitementQuantitatifUnivarie(Analyse_Notes);
   --   Res2 := TraitementQualitatifUnivarie(Analyse_Options);
   --	 Res3 := TraitementQualitatifQuantitatifBivvarie(Analyse_Options_Notes);
--   Res4 := TraitementQualitatifQualitatif(Analyse_Options_Origine);
--   New_Line;
--   New_Line;
--   AfficherTableau2D(Analyse_Options_Origine.Donnees,4,3);
--   New_Line;
--   Afficher(Res4);
--   New_Line;
--   AfficherTableau2D(Res4.Effectifs_Theoriques,4,3);
--   DELAY(100.000);

END ProjetAnalyse; --FIN
   