with ada.integer_text_io; use ada.integer_text_io;
with ada.float_text_io; use ada.float_text_io;
with ada.text_io; use ada.text_io;

package body etude is
	
   	DEBUG_MODE : constant boolean := false;
	procedure debug(debug_message : in string) is 
	begin
		if DEBUG_MODE then	
			put_line("Debug : " & debug_message);
		end if;
	end debug;

	procedure afficher(foo : etudiant) is
	begin
		put_line("Etudiant : " & integer'image(foo.id));
		put_line("->genre : " & foo.sexe);
		put_line("->age   : " & integer'image(foo.age));
		put_line("->departement : " & integer'image(foo.departement));
 	    put_line("->option : " & foo.option);
		put_line("->diplome : " & foo.diplome);
		put_line("->diplome option : " & foo.diplome_option);
		afficher(foo.promos);
	end afficher;

	procedure afficher(foo : promo) is
	begin
		put("   ->Promo : " & integer'image(foo.annee-1) & "/" & integer'image(foo.annee));
		put(" : " & foo.nom);
		put_line(" : " & foo.statut);
		afficher(foo.matieres);
	end afficher;

	procedure afficher(foo : module) is
	begin
		put_line("           ->Module : " & foo.nom);
		put_line("             Departement : " & foo.departement);
		put("             Resultat : ");put(foo.note,2,2,0); new_line;
	end afficher;
	
	procedure afficher(foo : in liste_etudiant) is
		aux : liste_etudiant;
	begin
		aux := foo;
		while aux /= null loop
			afficher(aux.all);
			new_line;
			aux := aux.all.next;
		end loop;
	end afficher;
	
	procedure afficher(foo : in liste_promo) is
		aux : liste_promo;
	begin
		aux := foo;
		while aux /= null loop
			afficher(aux.all);
			aux := aux.all.next;
		end loop;
	end afficher;
	
	procedure afficher(foo : in liste_module) is
		aux : liste_module;
	begin
		aux := foo;
		while aux /= null loop
			afficher(aux.all);
			aux := aux.all.next;
		end loop;
	end afficher;

	procedure addStudent(liste : in out liste_etudiant; element : in etudiant) is
	begin
		if liste = null then
			liste := new etudiant;
			liste.all := element;
		else
			addStudent(liste.all.next,element);
		end if;
	end addStudent;

	procedure addPromo(liste : in out liste_promo; element : in promo) is
	begin
		if liste = null then
			liste := new Promo;
			liste.all := element;
		else
			addPromo(liste.all.next,element);
		end if;
	end addPromo;

	procedure addModule(liste : in out liste_module; element : in module) is
	begin
		if liste = null then
			liste := new module;
			liste.all := element;
		else
			addModule(liste.all.next,element);
		end if;
	end addModule;

	--Ajoute un etudiant a une liste
	procedure get_next(liste : in out liste_etudiant; element : out Etudiant) is
	begin
		if liste /= null then
			element := liste.all;
			liste := liste.all.next;
		end if;
	end get_next;

	--Ajoute une promo a une liste
	procedure get_next(liste : in out liste_promo; element : out promo) is
	begin
		if liste /= null then
			element := liste.all;
			liste := liste.all.next;
		end if;
	end get_next;

	--Ajoute un module a une liste
	procedure get_next(liste : in out liste_module; element : out module) is
	begin
		if liste /= null then
			element := liste.all;
			liste := liste.all.next;
		end if;
	end get_next;

	function get_student(liste : liste_etudiant; id : integer) return liste_etudiant is
		aux : liste_etudiant;
	begin
		aux := liste;
		while aux /= null loop
			if aux.all.id = id then
				return aux;
			end if;
			aux := aux.all.next;
		end loop;
		return null;
	end get_student;

	function get_promo(liste : liste_promo; annee : year_number) return liste_promo is
		aux : liste_promo;
	begin
		aux := liste;
		while aux /= null loop
			if aux.all.annee = annee then
				return aux;
			end if;
			aux := aux.all.next;
		end loop;
		return null;
	end get_promo;

end etude;
