with ada.calendar; use ada.calendar;

package Etude is
	
	subtype t_note is float range 0.0..20.0;
	--package t_note_io is new enumeration_io(t_note); use t_note_io;
	
	type module;
	type liste_module is access module;

	--Module d'une anne
	type module is record
		nom : String(1..30) := (others => ' ');
		note : t_note := 0.0;
		departement : string(1..7) := (others => ' ');
		next : liste_module := null;
	end record;
	
	type Promo;
	type Liste_promo is access promo;

	type Promo is record
		nom : String(1..4) := (others => ' ');        --Exemple ING1, ING2, ING3
		statut : String(1..10) := (others => ' ');    --Statut de la promotion
		annee : year_number := 1901;                  --Type dans le package Calendar
		matieres : liste_module := null;              --Toutes les matieres d'une promo
		next : liste_promo := null;
	end record;

	type etudiant;
	type liste_etudiant is access etudiant;

	type Etudiant is
	record
		id : integer;                                      --ID Etudiant
		sexe : Character;                                  --Genre
		age : integer;                                     --Age
		departement : integer := 0;                        --Numero Departement
		option : String(1..7) := (others =>' ');           --Option 3eme anne
		Diplome : String(1..8) := (others =>' ');          --Origine pre-ING1
		diplome_option : String(1..19) := (others =>' ');  --Diplome associ a l'option
		promos : liste_promo := null;                      --Toutes les promotion de l'lve
		next : liste_etudiant := null;
		--TODO Faire des types
	end record;

	-----------------------FONCTION ETUDE-------------------------------
	--Affiche un etudiant
	procedure afficher(foo : in etudiant);
	--Affiche une promo
	procedure afficher(foo : in Promo);
	--Affiche un module
	procedure afficher(foo : in module);

	--Affiche une liste d'etudiant
	procedure afficher(foo : in liste_etudiant);
	--Affiche une liste de promo
	procedure afficher(foo : in liste_Promo);
	--Affiche une liste de modules
	procedure afficher(foo : in liste_module);

	--Ajoute un etudiant a une liste
	procedure addStudent(liste : in out liste_etudiant; element : in etudiant);
	--Ajoute une promo a une liste
	procedure addPromo(liste : in out liste_promo; element : in promo);
	--Ajoute un module a une liste
	procedure addModule(liste : in out liste_module; element : in module);

	--Ajoute un etudiant a une liste
	procedure get_next(liste : in out liste_etudiant; element : out etudiant);
	--Ajoute une promo a une liste
	procedure get_next(liste : in out liste_promo; element : out promo);
	--Ajoute un module a une liste
	procedure get_next(liste : in out liste_module; element : out module);

	--Recupere un pointeur vers un etudiant
	function get_student(liste : liste_etudiant; id : integer) return liste_etudiant;
	--Recupere un pointeur vers une promo
	function get_promo(liste : liste_promo; annee : year_number) return liste_promo;

	------------------------CONSTANTES------------------

	--nombre max d'etudiant dans le fichier etudians2004-2008
	last_etudiant : constant integer := 564;

end etude;
