WITH Text_IO, Ada.Float_Text_IO,Ada.Integer_Text_IO;
USE  Text_IO, Ada.Float_Text_IO,Ada.Integer_Text_IO;
WITH Ada.Numerics.Elementary_Functions;
USE Ada.Numerics.Elementary_Functions;
with ada.strings.fixed; use ada.strings.fixed;
with ada.strings; use ada.strings;

PACKAGE BODY Fctbivqualqual IS
	
   	dEBUG_MODE : constant boolean := true;
	procedure debug(debug_message : in string) is 
	begin
		if dEBUG_MODE then	
			put_line("Debug : " & debug_message);
		end if;
	end debug;

   PROCEDURE Afficher (
         Res : IN OUT RES_ANA_QUAL_X_QUAL) IS

   BEGIN
      Put("On s'interesse au ");
      Put(trim(Res.Qual1.Nom_Qualite,both));
      Put(" et au ");
      Put_Line(trim(Res.Qual2.Nom_Qualite,both));
      Put("X au carr vaut : ");
      Put(Res.X_2,4,2,0);
      New_Line;
      Put("Le CC vaut : ");
      Put(Res.CC,4,2,0);
      New_Line;
      Put("Le V de Kramer vaut :");
      Put(Res.V,4,2,0);
      New_Line;
   END Afficher;


   PROCEDURE AfficherTableau2D (
         Tab : T_EFFECTIFS_CARACTERE_X_CARACTERE;
         L   : Integer;
         C   : Integer) IS

   BEGIN
      FOR I IN 1 .. L LOOP
         Put("[ ");
         Put(Tab(I,1));
         FOR J IN 2 .. C LOOP
            Put(" ; ");
            Put(Tab(I,J));
         END LOOP;
         Put(" ]");
         New_Line;
      END LOOP;
   END AfficherTableau2D;

   PROCEDURE AfficherTableau2D (
         Tab : T_EFFECTIFS_THEORIQUE_CARACTERE_X_CARACTERE;
         L   : Integer;
         C   : Integer) IS

   BEGIN
      FOR I IN 1 .. L LOOP
         Put("[ ");
         Put(Tab(I,1),0,0,0);
         FOR J IN 2 .. C LOOP
            Put(" ; ");
            Put(Tab(I,J),0,0,0);
         END LOOP;
         Put(" ]");
         New_Line;
      END LOOP;
   END AfficherTableau2D;



   PROCEDURE AjoutEffectifMarginaux (
         MonAnalyseQualQual : IN OUT ANA_QUAL_X_QUAL) IS

      Colone       : Integer;
      Ligne        : Integer;
      TempMarginal : INTEGER;

   BEGIN
      Colone := MonAnalyseQualQual.Qual2.Nombre_Etats_Possibles;
      Ligne := MonAnalyseQualQual.Qual1.Nombre_Etats_Possibles;
      TempMarginal := 0;

	  --Calcul marge pour les lignes ( caractere 1 )
      FOR I IN 1..Ligne LOOP
         TempMarginal := 0;
         FOR J IN 1..Colone LOOP
            TempMarginal := TempMarginal + MonAnalyseQualQual.Donnees(I,J);
         END LOOP;
         MonAnalyseQualQual.Donnees(I,Colone+1) := TempMarginal;
      END LOOP;
      TempMarginal := 0;

	  --Calcul marge pour les colonnes ( caractere 2 )
      FOR J IN 1..Colone LOOP
         TempMarginal := 0;
         FOR I IN 1..Ligne LOOP
            TempMarginal := TempMarginal + MonAnalyseQualQual.Donnees(I,J);
         END LOOP;
         MonAnalyseQualQual.Donnees(Ligne+1,J) := TempMarginal;
      END LOOP;
      MonAnalyseQualQual.Donnees(Ligne+1,Colone+1) := MonAnalyseQualQual.Nb_Elements;

	  --reajustement de la structure
	  addState(MonAnalyseQualQual.qual1,"Marge");
	  addState(MonAnalyseQualQual.qual2,"Marge");

   END AjoutEffectifMarginaux;

   PROCEDURE AjoutEffectifMarginaux (
         Resultat : IN OUT RES_ANA_QUAL_X_QUAL) is

      Colone       : Integer;
      Ligne        : Integer;
      TempMarginal : float;
	  SommeMarginal: Float := 0.0;
   BEGIN
      Colone := Resultat.Qual2.Nombre_Etats_Possibles;
      Ligne := Resultat.Qual1.Nombre_Etats_Possibles;

	  --Calcul marge pour les lignes ( caractere 1 )
      FOR I IN 1..Ligne LOOP
         TempMarginal := 0.0;
         FOR J IN 1..Colone LOOP
            TempMarginal := TempMarginal + Resultat.Effectifs_Theoriques(I,J);
         END LOOP;
		 debug(" marge theo (" & integer'image(I) & ", " & integer'image(Colone+1) & ") : " & float'image(TempMarginal) );
         Resultat.Effectifs_Theoriques(I,Colone+1) := TempMarginal;
		 SommeMarginal := SommeMarginal + TempMarginal;
      END LOOP;

	  --Calcul marge pour les colonnes ( caractere 2 )
      FOR J IN 1..Colone LOOP
         TempMarginal := 0.0;
         FOR I IN 1..Ligne LOOP
            TempMarginal := TempMarginal + Resultat.Effectifs_Theoriques(I,J);
         END LOOP;
         Resultat.Effectifs_Theoriques(Ligne+1,J) := TempMarginal;
		 debug(" marge theo (" & integer'image(Ligne+1) & ", " & integer'image(J) & ") : " & float'image(TempMarginal) );
		 SommeMarginal := SommeMarginal + TempMarginal;
      END LOOP;
      Resultat.Effectifs_Theoriques(Ligne+1,Colone+1) := SommeMarginal;
	  debug(" marge theo (" & integer'image(Ligne+1) & ", " & integer'image(Colone+1) & ") : " & float'image(TempMarginal) );

   END AjoutEffectifMarginaux;

   procedure ComputeContingenceFrequence (
		 Resultat : in out RES_ANA_QUAL_X_QUAL;
         Analyse  : IN     ANA_QUAL_X_QUAL) IS
      Colone      : Integer;
      Ligne       : Integer;
   BEGIN
      Colone := Analyse.Qual2.Nombre_Etats_Possibles;
      Ligne  := Analyse.Qual1.Nombre_Etats_Possibles;

      FOR I IN 1..Ligne LOOP
         FOR J IN 1..Colone LOOP
            Resultat.Effectifs_Theoriques(I,J) := 
				Float( Analyse.Donnees(I,J) ) / Float( resultat.nb_elements );
         END LOOP;
      END LOOP;
	  --reajustement de la structure
	  addState(Resultat.qual1,"Marge");
	  addState(Resultat.qual2,"Marge");
   END  ComputeContingenceFrequence;
   
   function CreateContingenceTheorique (
		 Resultat : RES_ANA_QUAL_X_QUAL) 
		 return T_EFFECTIFS_THEORIQUE_CARACTERE_X_CARACTERE IS
      Colone      : Integer;
      Ligne       : Integer;
      MonResultat : T_EFFECTIFS_THEORIQUE_CARACTERE_X_CARACTERE := ( (others => (others => 0.0) ) );
   BEGIN
      Colone := Resultat.Qual2.Nombre_Etats_Possibles;
      Ligne := Resultat.Qual1.Nombre_Etats_Possibles;

      FOR I IN 1..Ligne LOOP
         FOR J IN 1..Colone LOOP
            MonResultat(I,J) := 
				Resultat.Effectifs_Theoriques(I,Colone) * Resultat.Effectifs_Theoriques(Ligne,J);
         END LOOP;
      END LOOP;
      RETURN MonResultat;
   END  CreateContingenceTheorique;

   FUNCTION CalculXcarre (
		 Resultat     : RES_ANA_QUAL_X_QUAL;
   		 tabContTheo  : T_EFFECTIFS_THEORIQUE_CARACTERE_X_CARACTERE
		)
     RETURN Float IS
	  Matrice1  : T_EFFECTIFS_THEORIQUE_CARACTERE_X_CARACTERE := resultat.Effectifs_Theoriques;
	  Matrice2  : T_EFFECTIFS_THEORIQUE_CARACTERE_X_CARACTERE := tabContTheo;
      Colone    : Integer;
      Ligne     : Integer;
      X         : Float := 0.0;
	  coef_theo : float := 0.0;
	  coef_Obs  : float := 0.0;
   BEGIN
      Colone := Resultat.Qual2.Nombre_Etats_Possibles-1; --On ne prendspas les marges en compte
      Ligne  := Resultat.Qual1.Nombre_Etats_Possibles-1; --On ne prendspas les marges en compte

      FOR I IN 1..Ligne LOOP
         FOR J IN 1..Colone LOOP
		 	coef_Obs  := float(Resultat.Nb_Elements) * Matrice1(I,J);
		 	coef_theo := float(Resultat.Nb_Elements) * Matrice2(I,J);
--		 	debug(" ->coord           : (" & integer'image(i) & "," & integer'image(j) & ")");
--		 	debug("   value X         : " & float'image(x));
--		 	debug("   value coef_obs  : " & float'image(coef_obs));
--		 	debug("   value coef_theo : " & float'image(coef_theo));
            X :=  X + ( ( coef_obs - coef_theo ) **2  / 
					       coef_theo ) ;
         END LOOP;
      END LOOP;
      RETURN X;
   END CalculXcarre;

   FUNCTION CalculCC (
		 Resultat : RES_ANA_QUAL_X_QUAL)
     RETURN Float IS
   BEGIN
      return Sqrt( resultat.X_2 / (resultat.X_2 + Float(resultat.Nb_Elements)));
   END CalculCC;

   FUNCTION CalculV (
		 Resultat     : RES_ANA_QUAL_X_QUAL)
     RETURN FLOAT IS
      Min    : integer;
   BEGIN
      Min := get_min(Resultat.qual1.Nombre_Etats_Possibles-1,Resultat.qual1.Nombre_Etats_Possibles-1);
      return Sqrt( resultat.X_2 / float( Resultat.Nb_Elements * (min-1)  ));
   END  CalculV;

   FUNCTION TraitementQualitatifQualitatif (
         Mon : IN     ANA_QUAL_X_QUAL)
     RETURN RES_ANA_QUAL_X_QUAL IS
      MesResultats    : RES_ANA_QUAL_X_QUAL;
      MonAnalQualQual : ANA_QUAL_X_QUAL;
	  tableauContingenceTheorique : T_EFFECTIFS_THEORIQUE_CARACTERE_X_CARACTERE;
   BEGIN
      MonAnalQualQual := Mon;
      MesResultats.Qual1 := MonAnalQualQual.Qual1;
      MesResultats.Qual2 := MonAnalQualQual.Qual2;
      MesResultats.Nb_Elements := MonAnalQualQual.Nb_Elements;
      AjoutEffectifMarginaux(MonAnalQualQual);

	  if DEBUG_MODE then
	  	new_line;
	  	debug("Contingence Effectif + Marge");
	  	afficher(MonAnalQualQual);
	  	new_line;
	  end if;

      ComputeContingenceFrequence(MesResultats,MonAnalQualQual);

	  if DEBUG_MODE then
	  	new_line;
	  	debug("Contingence Frequence + Marge");
	  	afficherTableau(MesResultats);
	  	new_line;
	  end if;

	  tableauContingenceTheorique := CreateContingenceTheorique( MesResultats );

	  if DEBUG_MODE then
	  	new_line;
	  	debug("Contingence Frequence Theorique + Marge");
	  	afficherTableau2D(
			tableauContingenceTheorique, 
			MesResultats.qual1.Nombre_Etats_Possibles, 
			MesResultats.qual2.Nombre_Etats_Possibles);
	  	new_line;
	  end if;

      MesResultats.X_2 := CalculXcarre( MesResultats, tableauContingenceTheorique );

	  if DEBUG_MODE then
	  	new_line;
		debug("calculXcarre");
		debug(float'image(MesResultats.X_2));
	  	new_line;
	  end if;

      MesResultats.CC  := CalculCC( MesResultats );

	  if DEBUG_MODE then
	  	new_line;
		debug("calculCC");
		debug(float'image(MesResultats.CC));
	  	new_line;
	  end if;

      MesResultats.V   := CalculV( MesResultats );

	  if DEBUG_MODE then
	  	new_line;
		debug("calculV");
		debug(float'image(MesResultats.V));
	  	new_line;
	  end if;

      RETURN MesResultats;
   END TraitementQualitatifQualitatif;

   ---------------------------------------------------------------------
   -----                     PARTIE SUPPLEMENTAIRE                ------
   ---------------------------------------------------------------------
   
   	function get_min(f1, F2 : integer) return integer is
	begin
		if f1 < F2 then
			return f1;
		else
			return f2;
		end if;
	end get_min;

	function compute_correct_spacing( qual : in qualite) return integer is
		max_length : natural := natural'first;
	begin
		for i in 1..qual.Nombre_Etats_Possibles loop
			if max_length < trim(qual.Etats_Possibles(i),both)'last then
				max_length := trim(qual.Etats_Possibles(i),both)'last;
			end if;
		end loop;
		return integer(max_length);
	end compute_correct_spacing;

	procedure addSpacing(n : in integer) is
	begin
		for i in 1..N loop
			put(" ");
		end loop;
	end addSpacing;
	
	procedure afficherTableau(analyse : in RES_ANA_QUAL_X_QUAL) is
	begin
		put_line(" Qualite 1    : " & analyse.qual1.Nom_qualite);
		put_line(" Qualite 2    : " & analyse.qual2.Nom_qualite);
		put_line(" nb _elements : " & integer'image(analyse.nb_elements));
		addSpacing( compute_correct_spacing(analyse.qual1)+2 );
		for I in 1..analyse.qual2.Nombre_Etats_Possibles loop
			put( trim(analyse.qual2.Etats_Possibles(I),both)  & "-");
		end loop;
		new_line;
		for i in 1..analyse.qual1.Nombre_Etats_Possibles loop
			put( trim(analyse.qual1.Etats_Possibles(I),both) );
			addSpacing( compute_correct_spacing(analyse.qual1) - trim(analyse.qual1.Etats_Possibles(I),both)'last );
			put(" [ ");
			for j in 1..analyse.qual2.Nombre_Etats_Possibles loop
--				put( analyse.Effectifs_Theoriques(i,j),trim(analyse.qual2.Etats_Possibles(J),both)'last - 2,2,0);
				put( analyse.Effectifs_Theoriques(i,j),2,2,0);
				if J /= analyse.qual2.Nombre_Etats_Possibles then
					put(", ");
				end if;
			end loop;
			put_line("]");
		end loop;
	end afficherTableau;
	
	procedure afficher(analyse : in ANA_QUAL_X_QUAL) is
	begin
		put_line(" Qualite 1    : " & analyse.qual1.Nom_qualite);
		put_line(" Qualite 2    : " & analyse.qual2.Nom_qualite);
		put_line(" nb _elements : " & integer'image(analyse.nb_elements));
		addSpacing( compute_correct_spacing(analyse.qual1)+2 );
		for I in 1..analyse.qual2.Nombre_Etats_Possibles loop
			put( trim(analyse.qual2.Etats_Possibles(I),both)  & "-");
		end loop;
		new_line;
		for i in 1..analyse.qual1.Nombre_Etats_Possibles loop
			put( trim(analyse.qual1.Etats_Possibles(I),both) );
			addSpacing( compute_correct_spacing(analyse.qual1) - trim(analyse.qual1.Etats_Possibles(I),both)'last );
			put(" [ ");
			for j in 1..analyse.qual2.Nombre_Etats_Possibles loop
				put( analyse.donnees(i,j), trim(analyse.qual2.Etats_Possibles(J),both)'last - 1);
				if J /= analyse.qual2.Nombre_Etats_Possibles then
					put(", ");
				end if;
			end loop;
			put_line("]");
		end loop;
	end afficher;

	procedure updateCounter(
	 	analyse : in out ANA_QUAL_X_QUAL; 
		position1 : in natural;                             --ligne correspondante a la qual1
		position2 : in natural                              --colonne correspondante a la qual2
		) is
	begin
		analyse.Donnees( position1, position2 ) := analyse.Donnees( position1, position2 ) + 1;
		analyse.nb_elements := analyse.nb_elements + 1;
	end updateCounter;
		
	procedure get_caracteres(
   		etudiants : in liste_etudiant;         --les etudiants
		choix1 : in mode_qualitatif;           --le caractere 1 choisi
		choix2 : in mode_qualitatif;           --le caractere 2 choisi
		analyse : out ANA_QUAL_X_QUAL          --structure a remplir
		)
		is
		aux_etu : liste_etudiant;
		aux_promo : liste_promo;
		aux_module : liste_module;

		etudiant_tmp : etudiant;
		Promo_tmp: promo;
		module_tmp : module;

		value_qual1 : String(1..100) := (others => ' ');
		value_qual2 : String(1..100) := (others => ' ');
	begin
		--Creation struct qualite
		Set_qualite_name(analyse.qual1,choix1);
		--Creation struct qualite
		Set_qualite_name(analyse.qual2,choix2);

		debug("structure qualite.qual1 cre : '" & trim(analyse.qual1.Nom_qualite,both) & "'");
		debug("structure qualite.qual2 cre : '" & trim(analyse.qual2.Nom_qualite,both) & "'");

		--Creation struct analyse qualite
		aux_etu := etudiants;
		while aux_etu /= null loop
			get_next(aux_etu,etudiant_tmp);

			if
				choix1 = genre or
				choix1 = option or
				choix1 = diplome or
				choix1 = diplome_option or
				choix1 = Origine_departement
				then
					declare
						value_tmp : string := extract_value(etudiant_tmp,choix1);
					begin
						value_qual1(value_tmp'range) := value_tmp;
					end;
			end if;
			if
				choix2 = genre or
				choix2 = option or
				choix2 = diplome or
				choix2 = diplome_option or
				choix2 = Origine_departement
				then
					declare
						value_tmp : string := extract_value(etudiant_tmp,choix2);
					begin
						value_qual2(value_tmp'range) := value_tmp;
					end;
			end if;
					
			aux_promo := etudiant_tmp.promos;
			while aux_promo /= null loop
				get_next(aux_promo,promo_tmp);

				if
					choix1 = nom_promo or
					choix1 = statut_promo
					then
						declare
							value_tmp : string := extract_value(promo_tmp,choix1);
						begin
							value_qual1(value_tmp'range) := value_tmp;
						end;
				end if;
				if
					choix2 = nom_promo or
					choix2 = statut_promo
					then
						declare
							value_tmp : string := extract_value(promo_tmp,choix2);
						begin
							value_qual2(value_tmp'range) := value_tmp;
						end;
				end if;

				aux_module := promo_tmp.matieres;
				while aux_module /= null loop
					get_next(aux_module,module_tmp);

					if
						choix1 = matiere
						then
							declare
								value_tmp : string := extract_value(module_tmp,choix1);
							begin
								value_qual1(value_tmp'range) := value_tmp;
							end;
					end if;
					if
						choix2 = matiere
						then
							declare
								value_tmp : string := extract_value(module_tmp,choix2);
							begin
								value_qual2(value_tmp'range) := value_tmp;
							end;
					end if;

				   debug("Etudiant " & integer'image(etudiant_tmp.id));
				   debug("   -> " & mode_qualitatif'image(choix1) & " : '" & trim(value_qual1,both) & "'");
				   debug("   -> " & mode_qualitatif'image(choix2) & " : '" & trim(value_qual2,both) & "'");
				
				   if index_non_blank(value_qual1) > 0 and index_non_blank(value_qual2) > 0 then 
				   		addState(analyse.qual1,trim(value_qual1,both));
					    addState(analyse.qual2,trim(value_qual2,both));
					    updateCounter(
							analyse,
							index(analyse.qual1,trim(value_qual1,both)),
							index(analyse.qual2,trim(value_qual2,both))
						);
					else
						debug("non ajout!");
				   end if;
					
				   if choix1 = matiere then
				   		value_qual1 := (others => ' ');
				   end if;
				   if choix2 = matiere then
				   		value_qual2 := (others => ' ');
				   end if;
				   
				end loop;--loop module
		   end loop;--loop promo
					
		   value_qual1 := (others => ' ');
		   value_qual2 := (others => ' ');
	   end loop;--loop etudiant
--
--
--							if ( choix1 = nom_promo  or choix1 = statut_promo ) and choix2 = matiere then  --Choix 1 est Promo et Choix 2 est Matiere	
--								declare
--									value_qual1 : String := extract_value(promo_tmp,choix1); --Recupere la valeur du caractere choisi
--									value_qual2 : String := extract_value(module_tmp,choix2);
--								begin
--									debug("Etudiant " & integer'image(etudiant_tmp.id));
--								 	debug("   -> " & mode_qualitatif'image(choix1) & " : '" & value_qual1 & "'");
--								 	debug("   -> " & mode_qualitatif'image(choix2) & " : '" & value_qual2 & "'");
--								 	debug("   -> " & mode_qualitatif'image(choix1) & " : " & integer'image(index_non_blank(value_qual1)));
--								 	debug("   -> " & mode_qualitatif'image(choix2) & " : " & integer'image(index_non_blank(value_qual2)));
--					
--									if index_non_blank(value_qual1) > 0 and index_non_blank(value_qual1) > 0 then
--										addState(analyse.qual1,value_qual1);
--										addState(analyse.qual2,value_qual2);
--										updateCounter(
--											analyse,
--											index(analyse.qual1,value_qual1),
--											index(analyse.qual2,value_qual2)
--										);
--									end if;
--								end ;
--							else                                         --Choix 1 est Matiere et Choix 2 est Promo
--							declare
--									value_qual1 : String := extract_value(module_tmp,choix1); --Recupere la valeur du caractere choisi
--									value_qual2 : String := extract_value(promo_tmp,choix2);
--								begin
--									debug("Etudiant " & integer'image(etudiant_tmp.id));
--								 	debug("   -> " & mode_qualitatif'image(choix1) & " : '" & value_qual1 & "'");
--								 	debug("   -> " & mode_qualitatif'image(choix2) & " : '" & value_qual2 & "'");
--					
--									if index_non_blank(value_qual1) > 0 and index_non_blank(value_qual1) > 0 then
--										addState(analyse.qual1,value_qual1);
--										addState(analyse.qual2,value_qual2);
--										updateCounter(
--											analyse,
--											index(analyse.qual1,value_qual1),
--											index(analyse.qual2,value_qual2)
--										);
--									end if;
--								end ;
--							end if;
--						end loop;
--					else
--						if choix1 = nom_promo or choix1 = statut_promo then	
--							declare
--								value_qual1 : String := extract_value(promo_tmp,choix1); --Recupere la valeur du caractere choisi
--								value_qual2 : String := extract_value(etudiant_tmp,choix2);
--							begin
--								debug("Etudiant " & integer'image(etudiant_tmp.id));
--							 	debug("   -> " & mode_qualitatif'image(choix1) & " : '" & value_qual1 & "'");
--							 	debug("   -> " & mode_qualitatif'image(choix2) & " : '" & value_qual2 & "'");
--							 	debug("   -> " & mode_qualitatif'image(choix1) & " : " & integer'image(index_non_blank(value_qual1)));
--							 	debug("   -> " & mode_qualitatif'image(choix2) & " : " & integer'image(index_non_blank(value_qual2)));
--				
--								if index_non_blank(value_qual1) > 0 and index_non_blank(value_qual1) > 0 then
--									addState(analyse.qual1,value_qual1);
--									addState(analyse.qual2,value_qual2);
--									updateCounter(
--										analyse,
--										index(analyse.qual1,value_qual1),
--										index(analyse.qual2,value_qual2)
--									);
--								end if;
--							end ;
--						else	
--							aux_module := promo_tmp.matieres;
--							while aux_module /= null loop
--								get_next(aux_module,module_tmp);
--								declare
--									value_qual1 : String := extract_value(module_tmp,choix1); --Recupere la valeur du caractere choisi
--									value_qual2 : String := extract_value(etudiant_tmp,choix2);
--								begin
--									debug("Etudiant " & integer'image(etudiant_tmp.id));
--								 	debug("   -> " & mode_qualitatif'image(choix1) & " : '" & value_qual1 & "'");
--								 	debug("   -> " & mode_qualitatif'image(choix2) & " : '" & value_qual2 & "'");
--								 	debug("   -> " & mode_qualitatif'image(choix1) & " : " & integer'image(index_non_blank(value_qual1)));
--								 	debug("   -> " & mode_qualitatif'image(choix2) & " : " & integer'image(index_non_blank(value_qual2)));
--					
--									if index_non_blank(value_qual1) > 0 and index_non_blank(value_qual1) > 0 then
--										addState(analyse.qual1,value_qual1);
--										addState(analyse.qual2,value_qual2);
--										updateCounter(
--											analyse,
--											index(analyse.qual1,value_qual1),
--											index(analyse.qual2,value_qual2)
--										);
--									end if;
--								end ;
--							end loop;
--						end if;
--					end if;
--				end loop;
--			else                                             --Choix 1 n'est pas Promo ou Matiere
--				if choix2 = nom_promo or choix2 = statut_promo or choix2 = matiere then   --Choix 2 est Promo ou Matiere
--					aux_promo := etudiant_tmp.promos;
--					while aux_promo /= null loop
--						get_next(aux_promo, promo_tmp);
--
--						if choix2 = nom_promo or choix2 = statut_promo then
--							declare
--								value_qual1 : String := extract_value(etudiant_tmp,choix1); --Recupere la valeur du caractere choisi
--								value_qual2 : String := extract_value(promo_tmp,choix2);
--							begin
--								debug("Etudiant " & integer'image(etudiant_tmp.id));
--							 	debug("   -> " & mode_qualitatif'image(choix1) & " : '" & value_qual1 & "'");
--							 	debug("   -> " & mode_qualitatif'image(choix2) & " : '" & value_qual2 & "'");
--							 	debug("   -> " & mode_qualitatif'image(choix1) & " : " & integer'image(index_non_blank(value_qual1)));
--							 	debug("   -> " & mode_qualitatif'image(choix2) & " : " & integer'image(index_non_blank(value_qual2)));
--				
--								if index_non_blank(value_qual1) > 0 and index_non_blank(value_qual1) > 0 then
--									addState(analyse.qual1,value_qual1);
--									addState(analyse.qual2,value_qual2);
--									updateCounter(
--										analyse,
--										index(analyse.qual1,value_qual1),
--										index(analyse.qual2,value_qual2)
--									);
--								end if;
--							end ;
--						end if;
--
--						aux_module := promo_tmp.matieres;
--						while aux_module /= null loop
--							get_next(aux_module,module_tmp);
--
--							if choix2 = matiere then
--								declare
--									value_qual1 : String := extract_value(etudiant_tmp,choix1); --Recupere la valeur du caractere choisi
--									value_qual2 : String := extract_value(module_tmp,choix2);
--								begin
--									debug("Etudiant " & integer'image(etudiant_tmp.id));
--								 	debug("   -> " & mode_qualitatif'image(choix1) & " : '" & value_qual1 & "'");
--								 	debug("   -> " & mode_qualitatif'image(choix2) & " : '" & value_qual2 & "'");
--								 	debug("   -> " & mode_qualitatif'image(choix1) & " : " & integer'image(index_non_blank(value_qual1)));
--								 	debug("   -> " & mode_qualitatif'image(choix2) & " : " & integer'image(index_non_blank(value_qual2)));
--					
--									if index_non_blank(value_qual1) > 0 and index_non_blank(value_qual1) > 0 then
--										addState(analyse.qual1,value_qual1);
--										addState(analyse.qual2,value_qual2);
--										updateCounter(
--											analyse,
--											index(analyse.qual1,value_qual1),
--											index(analyse.qual2,value_qual2)
--										);
--									end if;
--								end ;
--							end if;
--						end loop;
--					end loop;
--				else
--					declare
--						value_qual1 : String := extract_value(etudiant_tmp,choix1); --Recupere la valeur du caractere choisi
--						value_qual2 : String := extract_value(etudiant_tmp,choix2);
--					begin
--						debug("Etudiant " & integer'image(etudiant_tmp.id));
--					 	debug("   -> " & mode_qualitatif'image(choix1) & " : '" & value_qual1 & "'");
--					 	debug("   -> " & mode_qualitatif'image(choix2) & " : '" & value_qual2 & "'");
--					 	debug("   -> " & mode_qualitatif'image(choix1) & " : " & integer'image(index_non_blank(value_qual1)));
--					 	debug("   -> " & mode_qualitatif'image(choix2) & " : " & integer'image(index_non_blank(value_qual2)));
--		
--						if index_non_blank(value_qual1) > 0 and index_non_blank(value_qual1) > 0 then
--							addState(analyse.qual1,value_qual1);
--							addState(analyse.qual2,value_qual2);
--							updateCounter(
--								analyse,
--								index(analyse.qual1,value_qual1),
--								index(analyse.qual2,value_qual2)
--							);
--						end if;
--					end ;
--				end if;
--			end if;
--				
--		end loop;--loop  etudiant

		debug("fin remplissage structure");
		if debug_mode then
			new_line;
			afficher(analyse);
			new_line;
		end if;

	end get_caracteres;

END Fctbivqualqual;
