WITH FctUniQual;
USE FctUniQual;
WITH Const;
USE Const;
with etude; use etude;

PACKAGE FctBivQualQual IS


   TYPE T_EFFECTIFS_CARACTERE_X_CARACTERE IS ARRAY (1 .. (Max_Etats + 1), 1 .. (Max_Etats + 1)) OF Integer;
   TYPE T_EFFECTIFS_THEORIQUE_CARACTERE_X_CARACTERE IS ARRAY (1 .. (Max_Etats + 1), 1 .. (Max_Etats + 1)) OF Float;

   TYPE DOUBLET_QUAL_X_QUAL IS
      RECORD
         Val_Qual1 : String (1 .. 50) := (OTHERS => ' ');
         Val_Qual2 : String (1 .. 50) := (OTHERS => ' ');
      END RECORD;


   TYPE T_Doublet_QUAL_X_QUAL IS ARRAY (1 .. Max_Ele) OF DOUBLET_QUAL_X_QUAL;


   ----- On dfinie la structure ANA_QUAL_X_QUAL
   TYPE ANA_QUAL_X_QUAL IS
      RECORD
         Qual1       : QUALITE;
         Qual2       : QUALITE;
         Nb_Elements : Integer RANGE 0 .. Max_Ele := 0;
         Donnees     : T_EFFECTIFS_CARACTERE_X_CARACTERE := ( (others => (others => 0) ) );
      END RECORD;
   -------------------------------------



   ----- On dfinie la structure RES_ANA_QUAL_X_QUAL
   TYPE RES_ANA_QUAL_X_QUAL IS
      RECORD
         Qual1                : QUALITE;
         Qual2                : QUALITE;
         Nb_Elements          : Integer RANGE 0 .. Max_Ele := 0;
         X_2                  : FLOAT := 0.0;
         CC                   : FLOAT := 0.0;
         V                    : FLOAT := 0.0;
         Effectifs_Theoriques : T_EFFECTIFS_THEORIQUE_CARACTERE_X_CARACTERE := ( (others => (others => 0.0) ) );
      END RECORD;
   -------------------------------------
   PROCEDURE AjoutEffectifMarginaux (
         MonAnalyseQualQual : IN OUT ANA_QUAL_X_QUAL);
   PROCEDURE AjoutEffectifMarginaux (
         Resultat : IN OUT RES_ANA_QUAL_X_QUAL);
   procedure ComputeContingenceFrequence (
		 Resultat : in out RES_ANA_QUAL_X_QUAL;
         Analyse  : IN     ANA_QUAL_X_QUAL);
   function CreateContingenceTheorique (
		 Resultat : RES_ANA_QUAL_X_QUAL) 
		 return T_EFFECTIFS_THEORIQUE_CARACTERE_X_CARACTERE;
   FUNCTION CalculXcarre (
		 Resultat     : RES_ANA_QUAL_X_QUAL;
   		 tabContTheo  : T_EFFECTIFS_THEORIQUE_CARACTERE_X_CARACTERE)
     RETURN Float;
   FUNCTION CalculCC (
		 Resultat : RES_ANA_QUAL_X_QUAL)
     RETURN Float;
   FUNCTION CalculV (
		 Resultat     : RES_ANA_QUAL_X_QUAL)
     RETURN FLOAT;
   PROCEDURE Afficher (
         Res : IN OUT RES_ANA_QUAL_X_QUAL);
   FUNCTION TraitementQualitatifQualitatif (
         Mon : IN     ANA_QUAL_X_QUAL)
     RETURN RES_ANA_QUAL_X_QUAL;
--   PROCEDURE AfficherTableau2D (
--         Tab : T_EFFECTIFS_CARACTERE_X_CARACTERE;
--         L   : Integer;
--         C   : Integer);
--   PROCEDURE AfficherTableau2D (
--         Tab : T_EFFECTIFS_THEORIQUE_CARACTERE_X_CARACTERE;
--         L   : Integer;
--         C   : Integer);

	 ----------------------------------------------------
	 ---NOUVELLE PARTIE POUR RELIER ETUDIANT-CARACTERE---
	 ----------------------------------------------------
	 function get_min(f1, F2 : integer) return integer;
	 procedure afficher(analyse : in ANA_QUAL_X_QUAL);

	 procedure afficherTableau(analyse : in RES_ANA_QUAL_X_QUAL);

	 procedure updateCounter(
	 	analyse : in out ANA_QUAL_X_QUAL; 
		position1 : in natural;                             --ligne correspondante a la qual1
		position2 : in natural                              --colonne correspondante a la qual2
		) ;

	 procedure get_caracteres(
   		etudiants : in liste_etudiant;         --les etudiants
		choix1 : in mode_qualitatif;           --le caractere 1 choisi
		choix2 : in mode_qualitatif;           --le caractere 2 choisi
		analyse : out ANA_QUAL_X_QUAL          --structure a remplir
		);


END FctBivQualQual;

