WITH FctUniQual;
WITH FctUniQuant;
USE FctUniQual;
USE FctUniQuant;
WITH Const;
USE Const;
with etude; use etude;

PACKAGE FctBivQualQuant IS

   ----- On dfinie la structure DOUBLET_QUAL_QUANT
   TYPE DOUBLET_QUAL_QUANT IS
      RECORD
         Val_Qual  : String (1 .. 50) := (others =>' ');
         Val_Quant : Float:= 0.0;
      END RECORD;
   -------------------------------------

   TYPE T_DOUBLETS_QUAL_QUANT IS ARRAY (1 .. Max_Ele) OF DOUBLET_QUAL_QUANT;

   ----- On dfinie la structure ANA_QUAL_X_QUANT
   TYPE ANA_QUAL_X_QUANT IS
      RECORD
         Qual        : QUALITE;
         Quant       : QUANTITE;
         Nb_Elements : Integer RANGE 0 .. Max_Ele;
         Donnees     : T_DOUBLETS_QUAL_QUANT;
      END RECORD;
   -------------------------------------

   TYPE T_ANA_QUANT IS ARRAY (1 .. Max_Etats) OF ANA_QUANT;
   TYPE T_RES_ANA_QUANT IS ARRAY (1 .. Max_Etats) OF RES_ANA_QUANT;


   ----- On dfinie la structure RES_ANA_QUAL_X_QUANT
   TYPE RES_ANA_QUAL_X_QUANT IS
      RECORD
         Qual          : QUALITE;
         Quant         : QUANTITE;
         Nb_Elements   : Integer RANGE 0 .. Max_Ele := 0;
         Moyenne_Quant : Float := 0.0;
         Var_Tot       : Float := 0.0;
         Var_Intra     : Float := 0.0;
         Var_Inter     : Float := 0.0;
         Lien          : Float := 0.0;
         Res_Sous_Pop  : T_RES_ANA_QUANT;
      END RECORD;
   -------------------------------------

   FUNCTION DecoupageSousPopulations (
         MonAnalyseQualiteQuantite : ANA_QUAL_X_QUANT)
     RETURN T_ANA_QUANT;
   FUNCTION AnalyseUnivarieeSousPopulations (
         Tab              : T_ANA_QUANT;
         NbEtatsPossibles : Integer)
     RETURN T_RES_ANA_QUANT;
   FUNCTION CalculerMoyenneTotale (
         MonAnalyseQualiteQuantite : ANA_QUAL_X_QUANT)
     RETURN Float;
   FUNCTION CalculerVarianceTotale (
         MonAnalyseQualiteQuantite : ANA_QUAL_X_QUANT;
         MoyenneTotale             : Float)
     RETURN Float;
   FUNCTION CalculerVarianceInter (
         Tab           : T_RES_ANA_QUANT;
         NbElementsTab : Integer;
         MoyenneTotale : Float;
         Card          : Integer)
     RETURN Float;
   FUNCTION CalculerVarianceIntra (
         Tab           : T_RES_ANA_QUANT;
         NbElementsTab : Integer;
         Card          : Integer)
     RETURN Float;
   FUNCTION CalculerLien (
         VarianceTotale : Float;
         VarianceInter  : Float)
     RETURN Float;

	 ----------------------------------------------------
	 ---NOUVELLE PARTIE POUR RELIER ETUDIANT-CARACTERE---
	 ----------------------------------------------------

	 procedure afficher(analyse : in ANA_QUAL_X_QUANT);

	 procedure addElement(analyse : in out ANA_QUAL_X_QUANT; el_qual : in string; el_quant : in Float);

	 procedure get_caracteres(
   		etudiants : in liste_etudiant;         --les etudiants
		choix1 : in mode_qualitatif;           --le caractere 1 choisi
		choix2 : in mode_quantitatif;          --le caractere 2 choisi
		analyse : out ANA_QUAL_X_QUANT         --structure a remplir
		);

END FctBivQualQuant;
   
