WITH Text_IO, Ada.Integer_Text_IO, Ada.Float_Text_IO;
USE  Text_IO, Ada.Integer_Text_IO, Ada.Float_Text_IO;
with ada.strings.fixed; use ada.strings.fixed;
with ada.strings; use ada.strings;

PACKAGE BODY FctUniQual IS
	
	-------------------------------------------------------------------
	---         DEBUG MODE                                          ---
	-------------------------------------------------------------------
	
   	DEBUG_MODE : constant boolean := true;
	procedure debug(debug_message : in string) is 
	begin
		if DEBUG_MODE then	
			put_line("Debug : " & debug_message);
		end if;
	end debug;

   --------------------Procedure affichage pour l'analyse qualitative
   PROCEDURE Afficher (
         Mon_Resultat : IN     RES_ANA_QUAL) IS
   BEGIN
      Put("On s'interesse aux ");Put(Mon_Resultat.Qual.Nom_Qualite);New_Line;
      Put_Line("La repartition absolue est de :");
      FOR I IN 1..(Mon_Resultat.Qual.Nombre_Etats_Possibles) LOOP
         Put(trim(Mon_Resultat.Qual.Etats_Possibles(I),both));
         Put(" = ");
         Put(Mon_Resultat.Repartition_Absolue(I),0);
         New_Line;
      END LOOP;
      Put_Line("La repartition relative est de :");
      FOR I IN 1..(Mon_Resultat.Qual.Nombre_Etats_Possibles) LOOP
         Put(trim(Mon_Resultat.Qual.Etats_Possibles(I),both));
         Put(" = ");
         Put(Mon_Resultat.Repartition_Relative(I),1,2,0);
         New_Line;
      END LOOP;
   END Afficher;
   ------------------------fin procdure affichage

   ----on fait les algo du traitement qualitatif univari

   FUNCTION CalculRepartitionAbsolue (
         MonAnalyseQualitative : IN     ANA_QUAL)
     RETURN T_FREQUENCES_ABS IS
      Tab        : T_FREQUENCES_ABS;
      QualiteTMP : String (1 .. 50);
      Position   : INTEGER;
      J          : INTEGER;

   BEGIN
      J := 0;

      FOR I IN 1..MonAnalyseQualitative.Qual.Nombre_Etats_Possibles LOOP
         Tab(I) := 0;
      END LOOP;
      FOR I IN 1..MonAnalyseQualitative.Nb_Elements LOOP
         QualiteTMP := MonAnalyseQualitative.Donnees(I);
         FOR J IN 1..MonAnalyseQualitative.Qual.Nombre_Etats_Possibles LOOP
            IF QualiteTMP =   MonAnalyseQualitative.Qual.Etats_Possibles(
                  J) THEN
               Position := J;
            END IF;

         END LOOP;
         Tab(Position) := Tab(Position)+1;
      END LOOP;
      RETURN Tab;
   END CalculRepartitionAbsolue;



   FUNCTION CalculRepartitionRelative (
         MonAnalyseQualitative : IN     ANA_QUAL;
         Tab                   :        T_FREQUENCES_ABS)
     RETURN T_FREQUENCES_REL IS
      TabRes : T_FREQUENCES_REL;

   BEGIN

      FOR I IN 1..MonAnalyseQualitative.Qual.Nombre_Etats_Possibles LOOP
         TabRes(I) := Float(Tab(I))  / Float(
            MonAnalyseQualitative.Nb_Elements);
      END LOOP;
      RETURN TabRes;
   END CalculRepartitionRelative;

   -------------------------Fin des algos du traitement qualitatif univari

   FUNCTION TraitementQualitatifUnivarie (
         MonAnalyseQualitative : IN     ANA_QUAL)
     RETURN RES_ANA_QUAL IS

      MesResultats : RES_ANA_QUAL;

   BEGIN  ---dbut de la fonction TraitementQualitatiffUnivari

      MesResultats.Qual := MonAnalyseQualitative.Qual;
      MesResultats.Nb_Elements := MonAnalyseQualitative.Nb_Elements;
      MesResultats.Repartition_Absolue :=  CalculRepartitionAbsolue(
         MonAnalyseQualitative );
      MesResultats.Repartition_Relative := CalculRepartitionRelative(
         MonAnalyseQualitative,MesResultats.Repartition_Absolue);

      RETURN MesResultats;
   END TraitementQualitatifUnivarie;

   ---------------------------------------------------------------------
   -----                     PARTIE SUPPLEMENTAIRE                ------
   ---------------------------------------------------------------------

	procedure Set_qualite_name(qual : in out qualite;choix : in mode_qualitatif) is
	begin
		case choix is
			when genre =>
				declare
					nom_qualite : String := "Genre";
				begin
					qual.Nom_qualite(nom_qualite'range) := nom_qualite;
				end;
			when option =>
				declare
					nom_qualite : String := "Option";
				begin
					qual.Nom_qualite(nom_qualite'range) := nom_qualite;
				end;
			when Diplome =>
				declare
					nom_qualite : String := "Diplome";
				begin
					qual.Nom_qualite(nom_qualite'range) := nom_qualite;
				end;
			when Diplome_option =>
				declare
					nom_qualite : String := "Diplome Option";
				begin
					qual.Nom_qualite(nom_qualite'range) := nom_qualite;
				end;
			when matiere =>
				declare
					nom_qualite : String := "Matiere";
				begin
					qual.Nom_qualite(nom_qualite'range) := nom_qualite;
				end;
			when nom_promo =>
				declare
					nom_qualite : String := "Promo";
				begin
					qual.Nom_qualite(nom_qualite'range) := nom_qualite;
				end;
			when Statut_promo =>
				declare
					nom_qualite : String := "Statut Promo";
				begin
					qual.Nom_qualite(nom_qualite'range) := nom_qualite;
				end;
			when Origine_departement =>
				declare
					nom_qualite : String := "Origine Departementale";
				begin
					qual.Nom_qualite(nom_qualite'range) := nom_qualite;
				end;
		end case;
	end set_qualite_name;
		
	function is_in(qual : qualite; element : string) return boolean is
	begin
		for i in 1..qual.Nombre_Etats_Possibles loop
			if index(qual.Etats_Possibles(i),element) > 0 then
				return true;
			end if;
		end loop;
		return false;
	end is_in;

	procedure addState(qual : in out qualite; element : in string) is
	begin
		debug("->adding          : '" & element & "'");
		debug("  is_already_in   : '" & boolean'image(is_in( qual, element )) & "'");
		debug("  nombr element   : '" & integer'image(qual.Nombre_Etats_Possibles) & "'");
		if not is_in( qual, element ) then
			qual.Nombre_Etats_Possibles := qual.Nombre_Etats_Possibles + 1;
			qual.Etats_Possibles( qual.Nombre_Etats_Possibles )(element'range) := element;
		end if;
	end addState;
	
	function index(Qual : qualite;element : string) return natural is
	begin
		for i in 1..qual.Nombre_Etats_Possibles loop
			if index(qual.Etats_Possibles(i),element) > 0 then
				return I;
			end if;
		end loop;
		return 0;
	end index;

   procedure addElement(analyse_qualite : in out ana_qual; element : in String) is
   begin
		Analyse_qualite.nb_elements := Analyse_qualite.nb_elements + 1;
		Analyse_qualite.Donnees( Analyse_qualite.nb_elements )(element'range) := element;

		AddState(Analyse_qualite.qual, element);
   end addElement;

   procedure get_caractere(etudiants : in liste_etudiant;choix : in mode_qualitatif;
   								analyse_qualite : out ana_qual) is
		aux_etu : liste_etudiant;
		aux_promo : liste_promo;
		aux_module : liste_module;

		etudiant_tmp : etudiant;
		Promo_tmp: promo;
		module_tmp : module;

	begin
		--Creation struct qualite
		Set_qualite_name(analyse_qualite.qual,choix);

		debug("structure qualite cre : '" & trim(analyse_qualite.qual.Nom_qualite,both) & "'");

		--Creation struct analyse qualite
		aux_etu := etudiants;
		while aux_etu /= null loop
			get_next(aux_etu,etudiant_tmp);

			case choix is
				when genre =>                                                               --genre
					addElement(analyse_qualite,""&Etudiant_tmp.sexe);
					debug("ajout d'une donnee de type " & mode_qualitatif'image(choix));
				    debug(" -> " & analyse_qualite.Donnees( analyse_qualite.nb_elements ));
				when origine_departement =>                                                 --dept
					addElement(analyse_qualite, integer'image( Etudiant_tmp.departement ));
					debug("ajout d'une donnee de type " & mode_qualitatif'image(choix));
				    debug(" -> " & analyse_qualite.Donnees( analyse_qualite.nb_elements ));
				when option =>                                                              --origine
					addElement(analyse_qualite, Etudiant_tmp.option);
					debug("ajout d'une donnee de type " & mode_qualitatif'image(choix));
				    debug(" -> " & analyse_qualite.Donnees( analyse_qualite.nb_elements ));
				when diplome =>                                                             --diplome
					addElement(analyse_qualite,Etudiant_tmp.diplome);
					debug("ajout d'une donnee de type " & mode_qualitatif'image(choix));
				    debug(" -> " & analyse_qualite.Donnees( analyse_qualite.nb_elements ));
				when diplome_option =>                                                      --diplome option
					addElement(analyse_qualite,Etudiant_tmp.diplome_option);
					debug("ajout d'une donnee de type " & mode_qualitatif'image(choix));
				    debug(" -> " & analyse_qualite.Donnees( analyse_qualite.nb_elements ));
				when others =>                                                              
					aux_promo := etudiant_tmp.promos;
					while aux_promo /= null loop
						get_next(aux_promo,Promo_tmp);
		
						case choix is
							when nom_promo =>
								addElement(analyse_qualite,Promo_tmp.nom);
								debug("ajout d'une donnee de type " & mode_qualitatif'image(choix));
							    debug(" -> " & analyse_qualite.Donnees( analyse_qualite.nb_elements ));
							when statut_promo =>                                      --CHOISIR DE PRENDRE EN COMPTE LES ENTRANTS OU PAS
								addElement(analyse_qualite,Promo_tmp.statut);
								debug("ajout d'une donnee de type " & mode_qualitatif'image(choix));
							    debug(" -> " & analyse_qualite.Donnees( analyse_qualite.nb_elements ));
							when others =>
								aux_module := Promo_tmp.matieres;
								if aux_module = null then
									debug("Etudiant : " & integer'image(etudiant_tmp.id) & " -> Pas accs aux notes !");
								else
									while aux_module /= null loop
										get_next(aux_module, module_tmp);
										case choix is
											when matiere =>
												debug("ajout d'une donnee de type " & mode_qualitatif'image(choix));
												debug(" -> " & float'image(module_tmp.note));
												addElement(analyse_qualite,module_tmp.nom);
											when others =>
												put_line("Error choix non gr : " & mode_qualitatif'image(choix));
										end case;
								   end loop;
							   end if; --acces notes
						end case; -- case promo
				    end loop; --loop promo
			end case;--case etudiant
		end loop;--loop  etudiant

		debug("fin remplissage structure");
		debug("qualite   : " & Analyse_qualite.qual.Nom_qualite);
		debug("nb etats   : " & integer'image(Analyse_qualite.qual.Nombre_Etats_Possibles));
		for i in 1..Analyse_qualite.qual.Nombre_Etats_Possibles loop
			debug(" Etat " & integer'image(I) & " : " & trim(Analyse_qualite.qual.Etats_Possibles(I),both));
		end loop;
	end get_caractere;

	function extract_value(student : in etudiant; choix : mode_qualitatif) return String is
	begin
		debug("->extract etudiant : recuperation d'une donnee de type " & mode_qualitatif'image(choix));
		case choix is
				when genre =>                                                               --genre
				    debug(" -> " & student.sexe);
					return ""&student.sexe;
				when Origine_departement =>                                                 --dept
				    debug(" -> " & integer'image(student.departement));
					return integer'image(student.departement);
				when option =>                                                              --origine
				    debug(" -> " & student.option);
					return student.option;
				when diplome =>                                                             --diplome     
				    debug(" -> " & student.diplome);
					return student.diplome;
				when diplome_option =>                                                      --diplome option  
				    debug(" -> " & student.diplome_option);
					return student.diplome_option;
				when others =>   
					put_line("Error choix1 non gr : " & mode_qualitatif'image(choix));
		end case;--case etudiant
		return "";
	end extract_value;

	function extract_value(prom : in promo; choix : mode_qualitatif) return String is
	begin
		debug("->extract promo : recuperation d'une donnee de type " & mode_qualitatif'image(choix));
		case choix is
			when nom_promo =>                                                          --genre
				debug(" -> " & prom.nom);
				return prom.nom;
			when statut_promo =>                                                       --dept
				debug(" -> " & prom.statut);
				return prom.statut;
			when others =>   
				put_line("Error choix1 non gr : " & mode_qualitatif'image(choix));
		end case;--case etudiant
		return "";
	end extract_value;

	function extract_value(modu : in module; choix : mode_qualitatif) return string is
	begin
		debug("extract module : recuperation d'une donnee de type " & mode_qualitatif'image(choix));
		case choix is
			when matiere =>
				debug(" -> " & modu.nom);
				return modu.nom;
			when others =>
				put_line("Error : " & mode_qualitatif'image(choix));
		end case;
		return "";
	end extract_value;

END FctUniQual; --FIN 

      