WITH Const;
USE Const;
with ada.text_io; use ada.text_io;
with etude; use etude;

PACKAGE FctUniQual IS

   TYPE T_FREQUENCES_ABS IS ARRAY (1 .. Max_Etats) OF Integer ;
   TYPE T_FREQUENCES_REL IS ARRAY (1 .. Max_Etats) OF Float RANGE 0.0 .. 1.0 ;
   TYPE T_CARACTERES IS ARRAY (1 .. Max_Ele) OF String (1 .. 50);
   TYPE T_ETATS IS ARRAY (1 .. Max_Etats) OF String (1 .. 50);

   ----- On dfinie la structure qualit
   TYPE QUALITE IS
      RECORD
         Nom_Qualite            : String (1 .. 50) := (others => ' ');
         Nombre_Etats_Possibles : Integer RANGE 0 .. Max_Etats := 0;                    -- MODIF : 30 -> Max_Etats
         Etats_Possibles        : T_ETATS := (others => (others => ' '));
      END RECORD;
   -------------------------------------

   ----- On dfinie la structure ANA_QUAL
   TYPE ANA_QUAL IS
      RECORD
         Qual        : QUALITE;
         Nb_Elements : Integer RANGE 0 .. Max_Ele := 0;
         Donnees     : T_CARACTERES := (others => (others => ' '));
      END RECORD;
   -------------------------------------

   ----- On dfinie la structure RES_ANA_QUAL
   TYPE RES_ANA_QUAL IS
      RECORD
         Qual                 : QUALITE;
         Nb_Elements          : Integer RANGE 0 .. Max_Ele := 0;
         Repartition_Absolue  : T_FREQUENCES_ABS := (others => 0);
         Repartition_Relative : T_FREQUENCES_REL := (others => 0.0);
      END RECORD;
   -------------------------------------


   PROCEDURE Afficher (
         Mon_Resultat : IN     RES_ANA_QUAL);
   FUNCTION CalculRepartitionAbsolue (
         MonAnalyseQualitative : IN     ANA_QUAL)
     RETURN T_FREQUENCES_ABS;
   FUNCTION CalculRepartitionRelative (
         MonAnalyseQualitative : IN     ANA_QUAL;
         Tab                   :        T_FREQUENCES_ABS)
     RETURN T_FREQUENCES_REL;
   FUNCTION TraitementQualitatifUnivarie (
         MonAnalyseQualitative : IN     ANA_QUAL)
     RETURN RES_ANA_QUAL;

	 ----------------------------------------------------
	 ---NOUVELLE PARTIE POUR RELIER ETUDIANT-CARACTERE---
	 ----------------------------------------------------

	 --CHOISIR DE PRENDRE EN COMPTE LANNEE DE LA REMISE DES DIPLOME OU PAS ??!!
	--Creation d'un type qui enumere les modes qualitatif
   type Mode_Qualitatif is (
   		genre,
		option,
		diplome,
		diplome_option,
		matiere,
		nom_promo,
		statut_promo,
		Origine_departement
		);

		--Package pour le IO sur le type qualitatif
   package Mode_Qual_io is new Enumeration_io(mode_qualitatif); use Mode_qual_io;
   
   
   --Fixe le nom d'une structure qualit grce au type pass en paramtre
   procedure Set_qualite_name(qual : in out qualite;choix : in mode_qualitatif);

   --Teste si une qualit possede deja le mode pass en parametre
   function is_in(qual : qualite; element : string) return boolean;
   --Ajoute le mode donne a la qualit
   procedure addState(qual : in out qualite; element : in string);
   --renvoi l'index d'un mode dans le tableau de donnes de la structure qualit
   function index(Qual : qualite;element : string) return natural;
	
	--Ajoute un donne dans la structure analytique et mets  jour les variables adjacentes
	procedure addElement(analyse_qualite : in out ana_qual; element : in String);

	--Recupere toutes les donnes correspondant au caractere chosii dans les etudiants et les mets dans la structure analytique
	procedure get_caractere(
   		etudiants : in liste_etudiant;         --les etudiants
		choix : in mode_qualitatif;           --le caractere choisi
		analyse_qualite : out ana_qual);     --structure a remplir

   function extract_value(student : in etudiant; choix : mode_qualitatif) return String;
   function extract_value(prom : in promo; choix : mode_qualitatif) return String;
   function extract_value(modu : in module; choix : mode_qualitatif) return String;


END FCtUniQUal;

