WITH Ada.Numerics.Elementary_Functions;
USE Ada.Numerics.Elementary_Functions;
WITH Text_IO, Ada.Float_Text_IO;
USE  Text_IO, Ada.Float_Text_IO;
with ada.strings.fixed; use ada.strings.fixed;
with ada.strings; use ada.strings;

PACKAGE BODY FctUniQuant IS
	
   	DEBUG_MODE : constant boolean := true;
	procedure debug(debug_message : in string) is 
	begin
		if DEBUG_MODE then	
			put_line("Debug : " & debug_message);
		end if;
	end debug;

   PROCEDURE TrierTableauCroissant (
         MaQuantite : IN OUT ANA_QUANT) IS
      MonTab   : T_REELS := MaQuantite.Donnees;
      Desordre : Boolean;
      Tmp      : Float;

   BEGIN
      Desordre := True;
      WHILE Desordre = True LOOP
         Desordre := False;
         --par defaut, on considere que le tableau est rang
         FOR I IN 1..(MaQuantite.Nb_Elements-1) LOOP
            IF( MonTab(I) > MonTab(I+1) ) THEN
               --l'ordre est mauvais, on inverse
               Tmp := MonTab(I);
               MonTab(I) := MonTab(I+1);
               MonTab(I+1) := Tmp;
               Desordre := True; --l'ordre n'est pas encore rtabli
            END IF;
         END LOOP;
      END LOOP;
      MaQuantite.Donnees := MonTab;
   END
      TrierTableauCroissant; --FIN


   FUNCTION CalculerMoyenne (
         MaQuantite : IN     ANA_QUANT)
     RETURN Float IS
      Somme : Float;

   BEGIN
      Somme:=0.0;
      FOR I IN 1..MaQuantite.Nb_Elements LOOP
         Somme := Somme + MaQuantite.Donnees(I);
      END LOOP;
      RETURN (Somme/Float(MaQuantite.Nb_Elements));

   END Calculermoyenne; --FIN



   FUNCTION CalculerMin (
         MaQuantite : IN     ANA_QUANT)
     RETURN Float IS
      Min : Float;

   BEGIN
      Min := MaQuantite.Donnees(1);
      FOR I IN 2..MaQuantite.Nb_Elements LOOP
         IF(MaQuantite.Donnees(I)<Min) THEN
            Min:=MaQuantite.Donnees(I);
         END IF;
      END LOOP;
      RETURN Min;

   END CalculerMin; --FIN

   FUNCTION CalculerMax (
         MaQuantite : IN     ANA_QUANT)
     RETURN Float IS
      Max : Float;

   BEGIN
      Max := MaQuantite.Donnees(1);
      FOR I IN 2..MaQuantite.Nb_Elements LOOP
         IF (MaQuantite.Donnees(I) > Max) THEN
            Max:=MaQuantite.Donnees(I);
         END IF;
      END LOOP;
      RETURN Max;

   END CalculerMax; --FIN


   FUNCTION CalculerVariance (
         MaQuantite : IN     ANA_QUANT;
         Moyenne    : IN     Float)
     RETURN Float IS
      Variance : Float;

   BEGIN
      Variance :=0.0;
      FOR I IN 1..MaQuantite.Nb_Elements LOOP
         Variance := Variance + (MaQuantite.Donnees(I)-Moyenne)*(
            MaQuantite.Donnees(I)-Moyenne);
      END LOOP;
      Variance := Variance / Float(MaQuantite.Nb_Elements);
      RETURN Variance;
   END CalculerVariance; --FIN

   FUNCTION CalculerEcartType (
         MaVariance : IN     Float)
     RETURN Float IS
   BEGIN
      RETURN Sqrt(MaVariance);
   END CalculerEcartType; --FIN

   PROCEDURE CalculerQuantiles (
         MaQuantite : IN     ANA_QUANT;
         Mediane    : IN OUT Float;
         Quartile1  : IN OUT Float;
         Quartile3  : IN OUT Float) IS
   BEGIN
      IF(MaQuantite.Nb_Elements mod 2)=1 THEN
         --le nombre d'lments est impair
         Mediane := MaQuantite.Donnees(MaQuantite.Nb_Elements/2 + 1);
      ELSE
         --on fait la moyenne des deux cases du milieu
         Mediane := ( MaQuantite.Donnees(MaQuantite.Nb_Elements/2 + 1) +
            MaQuantite.Donnees(MaQuantite.Nb_Elements/2) ) / 2.0;
      END IF;

      --on calcule maintenant les quartiles
      IF(MaQuantite.Nb_Elements mod 4 = 0) THEN
         Quartile1 := MaQuantite.Donnees(MaQuantite.Nb_Elements/4);
         Quartile3 := MaQuantite.Donnees(Integer(0.75 * Float(
                  MaQuantite.Nb_Elements)));
      ELSE
         IF (MaQuantite.Nb_Elements mod 4 = 1) THEN
            Quartile1 := MaQuantite.Donnees(MaQuantite.Nb_Elements/4 + 1);
            Quartile3 := MaQuantite.Donnees(Integer(0.75 * Float(
                     MaQuantite.Nb_Elements) + 1.0));
         ELSE
            IF (MaQuantite.Nb_Elements mod 4 = 2) THEN
               Quartile1 := MaQuantite.Donnees(MaQuantite.Nb_Elements/4 +
                  2);
               Quartile3 := MaQuantite.Donnees(Integer(0.75 * Float(
                        MaQuantite.Nb_Elements) + 2.0));
            ELSE --(MaQuantite.Nb_Elements mod 4) = 2
               Quartile1 := MaQuantite.Donnees(MaQuantite.Nb_Elements/4 +
                  3);
               Quartile3 := MaQuantite.Donnees(Integer(0.75 * Float(
                        MaQuantite.Nb_Elements) + 3.0));
            END IF;
         END IF;
      END IF;


   END CalculerQuantiles; --FIN

   ------ Affichage RES_ANA_QUANT
   PROCEDURE Afficher (
         Mon_Resultat : IN     RES_ANA_QUANT) IS
   BEGIN
      Put("On s'intresse aux ");
      Put( trim(Mon_Resultat.Quant.Nom_Quantite, both) );
      New_Line;
      Put("La moyenne est de : ");
      Put(Mon_Resultat.Moyenne,2,2,0);
      New_Line;
      Put("La variance est de : ");
      Put(Mon_Resultat.Variance,3,2,0);
      New_Line;
      Put("L'ecart-type est de : ");
      Put(Mon_Resultat.Ecart_Type,3,2,0);
      New_Line;
      Put("La valeur mdiane est : ");
      Put(Mon_Resultat.Mediane,2,2,0);
      New_Line;
      Put("La valeur minimale est : ");
      Put(Mon_Resultat.Min,2,2,0);
      New_Line;
      Put("La valeur maximale est : ");
      Put(Mon_Resultat.Max,2,2,0);
      New_Line;
      Put("La valeur du premier quartile est : ");
      Put(Mon_Resultat.Premier_Quartile,2,2,0);
      New_Line;
      Put("La valeur du troisieme quartile est : ");
      Put(Mon_Resultat.Troisieme_Quartile,2,2,0);
      New_Line;
   END Afficher; --FIN
   ------------------------------


   FUNCTION TraitementQuantitatifUnivarie (
         MAQ : IN     ANA_QUANT)
     RETURN RES_ANA_QUANT IS

      MonAnalyseQuantitative : ANA_QUANT     := MAQ;
      MesResultats           : RES_ANA_QUANT;

   BEGIN -- dbut de la fonction TraitementQuantitatifUnivari
      MesResultats.Quant := MonAnalyseQuantitative.Quant;
      MesResultats.Nb_Elements := MonAnalyseQuantitative.Nb_Elements;
      TrierTableauCroissant(MonAnalyseQuantitative);
      MesResultats.Moyenne := CalculerMoyenne(MonAnalyseQuantitative);
      MesResultats.Min := CalculerMin(MonAnalyseQuantitative);
      MesResultats.Max := CalculerMax(MonAnalyseQuantitative);
      MesResultats.Variance := CalculerVariance(MonAnalyseQuantitative,
         MesResultats.Moyenne);

      MesResultats.Ecart_Type := CalculerEcartType(MesResultats.Variance);
      CalculerQuantiles(MonAnalyseQuantitative,MesResultats.Mediane,
         MesResultats.Premier_Quartile,MesResultats.Troisieme_Quartile);

--      Afficher(MesResultats);

      RETURN MesResultats;

   END TraitementQuantitatifUnivarie; --FIN

   ---------------------------------------------------------------------
   -----                     PARTIE SUPPLEMENTAIRE                ------
   ---------------------------------------------------------------------

   procedure addElement(analyse_quantite : in out ana_quant; element : in float) is
   begin
		Analyse_quantite.nb_elements := Analyse_quantite.nb_elements + 1;
		Analyse_quantite.Donnees( Analyse_quantite.nb_elements ) := element;

		if( Analyse_quantite.Donnees( Analyse_quantite.nb_elements ) < Analyse_quantite.quant.valeur_min ) then
			Analyse_quantite.quant.valeur_min := Analyse_quantite.Donnees( Analyse_quantite.nb_elements );
		end if;
		if( Analyse_quantite.Donnees( Analyse_quantite.nb_elements ) > Analyse_quantite.quant.valeur_max ) then
			Analyse_quantite.quant.valeur_max := Analyse_quantite.Donnees( Analyse_quantite.nb_elements );
		end if;
   end addElement;
   
   procedure Set_quantite_name(quant : in out quantite;choix : in mode_quantitatif) is
   begin
		case choix is
			when age =>
				declare
					nom_quantite : String := "Age";
				begin
					quant.Nom_Quantite(nom_quantite'range) := nom_quantite;
				end;
			when note_math =>
				declare
					nom_quantite : String := "Notes Mathematiques";
				begin
					quant.Nom_Quantite(nom_quantite'range) := nom_quantite;
				end;
			when note_dge =>
				declare
					nom_quantite : String := "Notes DGE";
				begin
					quant.Nom_Quantite(nom_quantite'range) := nom_quantite;
				end;
			when note_info =>
				declare
					nom_quantite : String := "Notes Informatique";
				begin
					quant.Nom_Quantite(nom_quantite'range) := nom_quantite;
				end;
			when note_phy_eln =>
				declare
					nom_quantite : String := "Notes Physique/Electronique";
				begin
					quant.Nom_Quantite(nom_quantite'range) := nom_quantite;
				end;
			when note_rh =>
				declare
					nom_quantite : String := "Notes Relations Humaines";
				begin
					quant.Nom_Quantite(nom_quantite'range) := nom_quantite;
				end;
			when note_varia =>
				declare
					nom_quantite : String := "Notes VARIA";
				begin
					quant.Nom_Quantite(nom_quantite'range) := nom_quantite;
				end;
			when note_option =>
				declare
					nom_quantite : String := "Notes Option";
				begin
					quant.Nom_Quantite(nom_quantite'range) := nom_quantite;
				end;
			when note_all =>
				declare
					nom_quantite : String := "Toutes les notes";
				begin
					quant.Nom_Quantite(nom_quantite'range) := nom_quantite;
				end;
		end case;
	end set_quantite_name;

   function extract_value(student : in etudiant; choix : Mode_Quantitatif) return float is
	begin
		debug("->recuperation d'une donnee de type " & mode_quantitatif'image(choix));
		case choix is
			when age =>  
				debug(" -> " & integer'image(student.age));                                                             --age
				return float(student.age);
			when others =>   
				put_line("Error choix1 non gr : " & mode_quantitatif'image(choix));
		end case;--case etudiant
		return -1.0; --age non trouv
   end extract_value;

   function extract_value(module_tmp : in module; choix : Mode_Quantitatif) return float is
   begin
		if DEBUG_MODE then
			new_line;
		end if;
   		debug("->recuperation d'une donnee de type " & mode_quantitatif'image(choix));
		debug(" ->departement : " & trim(module_tmp.departement,both));
		case choix is
			when note_math =>
				if index(module_tmp.departement,"MATH") > 0 then
				    debug(" -> " & float'image(module_tmp.note));
					return module_tmp.note;
				else
					debug(" -> Ne correspond pas a : " & "MATH");
				end if;
			when note_dge =>
				if index(module_tmp.departement,"DGE") > 0 then
				    debug(" -> " & float'image(module_tmp.note));
					return module_tmp.note;
				else
					debug(" -> Ne correspond pas a : " & "DGE");
				end if;
			when note_info =>
				if index(module_tmp.departement,"INFO") > 0 then
				    debug(" -> " & float'image(module_tmp.note));
					return module_tmp.note;
				else
					debug(" -> Ne correspond pas a : " & "INFO");
				end if;
			when note_phy_eln =>
				if index(module_tmp.departement,"PHY ELN") > 0 then
				    debug(" -> " & float'image(module_tmp.note));
					return module_tmp.note;
				else
					debug(" -> Ne correspond pas a : " & "PHY ELN");
				end if;
			when note_rh =>
				if index(module_tmp.departement,"RE HUM") > 0 then
				    debug(" -> " & float'image(module_tmp.note));
					return module_tmp.note;
				else
					debug(" -> Ne correspond pas a : " & "RE HUM");
				end if;
			when note_varia =>
				if index(module_tmp.departement,"VARIA") > 0 then
				    debug(" -> " & float'image(module_tmp.note));
					return module_tmp.note;
				else
					debug(" -> Ne correspond pas a : " & "VARIA");
				end if;
			when note_option =>
				if index(module_tmp.departement,"OPTION") > 0 then
				    debug(" -> " & float'image(module_tmp.note));
					return module_tmp.note;
				else
					debug(" -> Ne correspond pas a : " & "OPTION");
				end if;
			when note_All =>
				debug(" -> " & float'image(module_tmp.note));
				return module_tmp.note;
			when others =>
				put_line(" ->Error : " & mode_quantitatif'image(choix));
		end case;
		return -1.0; --Matiere non trouv
   end extract_value;
	
	procedure get_caractere(etudiants : in liste_etudiant;choix : in mode_quantitatif;
   								analyse : out ana_quant) is
		aux_etu : liste_etudiant;
		aux_promo : liste_promo;
		aux_module : liste_module;

		etudiant_tmp : etudiant;
		promo_tmp : promo;
		module_tmp : module;
	begin
		--Creation struct quantite
		set_quantite_name(analyse.quant,choix);

		debug("structure quantite cre : '" & trim(analyse.quant.Nom_Quantite,both) & "'");

		--Creation struct analyse quantite
		aux_etu := etudiants;
		while aux_etu /= null loop
			get_next(aux_etu,etudiant_tmp);

			case choix is
				when age =>                                          --age
					addElement(analyse,Float(Etudiant_tmp.age));
					debug("ajout d'une donnee de type " & mode_quantitatif'image(choix));
				    debug(" -> " & float'image(analyse.Donnees( analyse.nb_elements )));
				when others =>                                       --notes
					aux_promo := etudiant_tmp.promos;
					while aux_promo /= null loop
						get_next(aux_promo,promo_tmp);
		
						aux_module := promo_tmp.matieres;
						if aux_module = null then
							debug("Etudiant : " & integer'image(etudiant_tmp.id) & "Pas accs aux notes !");
						else
							while aux_module /= null loop
								get_next(aux_module, module_tmp);
--EXTRACT VALUE HERE !!
								case choix is
									when note_math =>
										if index(module_tmp.departement,"MATH") > 0 then
											debug("ajout d'une donnee de type " & mode_quantitatif'image(choix));
										    debug(" -> " & float'image(module_tmp.note));
											addElement(analyse,module_tmp.note);
										end if;
									when note_dge =>
										if index(module_tmp.departement,"DGE") > 0 then
											debug("ajout d'une donnee de type " & mode_quantitatif'image(choix));
										    debug(" -> " & float'image(module_tmp.note));
											addElement(analyse,module_tmp.note);
										end if;
									when note_info =>
										if index(module_tmp.departement,"INFO") > 0 then
											debug("ajout d'une donnee de type " & mode_quantitatif'image(choix));
										    debug(" -> " & float'image(module_tmp.note));
											addElement(analyse,module_tmp.note);
										end if;
									when note_phy_eln =>
										if index(module_tmp.departement,"PHY ELN") > 0 then
											debug("ajout d'une donnee de type " & mode_quantitatif'image(choix));
										    debug(" -> " & float'image(module_tmp.note));
											addElement(analyse,module_tmp.note);
										end if;
									when note_rh =>
										if index(module_tmp.departement,"RE HUM") > 0 then
											debug("ajout d'une donnee de type " & mode_quantitatif'image(choix));
										    debug(" -> " & float'image(module_tmp.note));
											addElement(analyse,module_tmp.note);
										end if;
									when note_varia =>
										if index(module_tmp.departement,"VARIA") > 0 then
											debug("ajout d'une donnee de type " & mode_quantitatif'image(choix));
										    debug(" -> " & float'image(module_tmp.note));
											addElement(analyse,module_tmp.note);
										end if;
									when note_option =>
										if index(module_tmp.departement,"OPTION") > 0 then
											debug("ajout d'une donnee de type " & mode_quantitatif'image(choix));
										    debug(" -> " & float'image(module_tmp.note));
											addElement(analyse,module_tmp.note);
										end if;
									when note_All =>
										debug("ajout d'une donnee de type " & mode_quantitatif'image(choix));
										debug(" -> " & float'image(module_tmp.note));
										addElement(analyse,module_tmp.note);
									when others =>
										put_line("Error : " & mode_quantitatif'image(choix));
								end case;
						   end loop;
							
						end if;

						
				    end loop;
			end case;

		end loop;

		debug("fin remplissage structure");
		debug("quantite   : " & analyse.quant.Nom_Quantite);
		debug("valeur min : " & float'image(analyse.quant.valeur_min));
		debug("valeur max : " & float'image(analyse.quant.valeur_max));
	end get_caractere;

END FctUniQuant; --FIN   