with ada.text_io; use ada.text_io;
with ada.strings.fixed;use ada.strings.fixed;
with ada.integer_text_io; use ada.integer_text_io; 

package body p_file is 
	
   	DEBUG_MODE : constant boolean := false;
	procedure debug(debug_message : in string) is 
	begin
		if DEBUG_MODE then	
			put_line("Debug : " & debug_message);
		end if;
	end debug;
	
--------------METHODE LISTE LIGNE------------------------------------------------

	--affiche le contenu d'une liste
	procedure afficher(liste : in liste_ligne) is 
		nb : integer := count(liste);
		aux : liste_ligne ;
	begin
		aux := liste;
		Put("[");
		for I in 1..nb loop
			put(aux.all.numero,0);
			if I /= nb  then
				put(", ");
			end if;
			aux := aux.all.next;
		end loop;
		put_line("]");
	end afficher;

	--compte le nb_d'element
	function count(liste : liste_ligne) return integer is
	begin
		if liste = null then
			return 0;
		else
			return 1 + count(liste.all.next);
		end if;
	end count;

	--ajoute un element tri
	procedure sortedAppend(liste : in out liste_ligne; element : in integer) is
		aux : liste_ligne;
		back : liste_ligne;
	begin
		if liste = null then 
			liste:=new ligne'(element,null);
        else 
			Aux:=liste;
			while Aux /= null loop
				if element < aux.all.numero then
					exit;
				end if;
				back:= aux;
				Aux:=Aux.All.next;
			end loop;
			if aux = null then                                      --Ajout en fin
				back.all.next :=new ligne'(element,null);
			else
				declare
					tmp : liste_ligne := new ligne'(element,aux);
				begin
					if back = null then                             --Ajout  en tte
						liste := tmp;
					else                                            -- Ajout quelque part
						back.all.next := tmp;
					end if;
				end;
			end if;
		end if;
	end sortedAppend;

	procedure get_next(file : in out liste_ligne; element : out integer) is
	begin
		if file /= null then
			element := file.all.numero;
			file := file.all.next;
		end if;
	end get_next;

	procedure ajust_lignes(liste : in out liste_ligne) is
		aux : liste_ligne;
	begin
		aux := liste;
		while aux /= null loop
			aux.all.numero := aux.all.numero + OFFSET;
			aux := aux.all.next;
	   	end loop;
   	end ajust_lignes;

	function array_to_queue( t : t_integer) return liste_ligne is
		liste : liste_ligne;
	begin
		for i in t'range loop
			sortedAppend(liste,t(I));
		end loop;
		return liste;
	end array_to_queue;


	---------------FONCTION FICHIER----------------------------------

	function compute_float_value(text : string) return float is
		pos : integer := index(text,",");
	begin
		if( pos > 0 ) then
			debug(" old slice : " & text);
			debug(" new slice : " & replace_slice(text, pos, pos + 1, "."));
			debug(" char a pos : " & text(pos) & "(" & integer'image(pos) & ")");
			debug(" computed value : " & float'image(float'value( replace_slice(text, pos, pos + 1, "."))) );
			return float'value( replace_slice(text, pos, pos, ".") );
		else
			return float'value( text );
		end if;
	end compute_float_value;

	procedure get_students(lignes : in liste_ligne; etudiants : out liste_etudiant) is
		buffer : file_type;                                      --Fichier
		string_buffer : string(1..100) := (others => ' ');       --Recuperation d'une ligne
		n : integer;                                             --nombre de caracteres lu
		aux : liste_ligne;
		num_ligne : integer;
	begin
		debug("infos etudiants");
	--------------------------------INFOS ETUDIANTS-----------------------------------------------
	
		open(buffer, in_file,"etudiants2004-2008.txt");          --Fichier pour la creation d'tudiant

		aux := lignes;
		ajust_lignes(aux);
		while aux /= null loop
			get_next(aux, num_ligne);
 	    	set_line(buffer, positive_count(num_ligne));
			get_line(buffer,string_buffer,n);                    --Recuperation de la ligne

			ajout_etudiant:declare
				tmp : etudiant;
		begin
				tmp.id := Integer'value(string_buffer(1..7));    --id
				tmp.sexe := string_buffer(9);                    --genre
				tmp.age := Integer'value(String_buffer(11..13)); --age
				tmp.option := String_buffer(15..21);             --option
				tmp.diplome := String_buffer(23..30);            --diplome
				tmp.diplome_option := String_buffer(32..n);      --option diplome

				AddStudent(etudiants, tmp);
			end ajout_etudiant;

			string_buffer := (others => ' ');
		end loop;
		close(buffer);

		debug("infos dept");
		---------------------------INFO DEPT-----------------------------------------

		open(buffer, in_file, "etu_origine_departementale.txt");

		set_line(buffer, 3);
		while not end_of_file(buffer) and line(buffer) < 875 loop
			get_line(buffer, string_buffer, n);

			if n >= 8 then 
				update_dept:declare
					id_buffer : integer;
					p_student : liste_etudiant;
				begin
					id_buffer := integer'value(string_buffer(1..8));
					p_student := get_student(etudiants,id_buffer);
					if p_student /= null then
						debug("---------------------------------------");
						debug(" dept : '" & string_buffer(11..12) & "'");
						debug("---------------------------------------");
						if Index_Non_Blank(string_buffer(11..12)) > 0 then
							p_student.all.departement := integer'value(string_buffer(11..12));
						end if;
					end if;
				end update_dept;
			end if;

			string_buffer := (others => ' ');
		end loop;
		close(buffer);

		debug("infos statut");
		---------------------------INFO STATUT-----------------------------------------

		open(buffer, in_file, "statut_etu.txt");

		set_line(buffer, 3);
		while not end_of_file(buffer) and line(buffer) < 2045 loop
			get_line(buffer, string_buffer, n);
			
			update_promo:declare
				id_buffer : integer;
				p_student : liste_etudiant;
			begin
				id_buffer := integer'value(string_buffer(1..8));
				p_student := get_student(etudiants,id_buffer);
				if p_student /= null then
					create_promo:declare
						prom : promo;
					begin
						debug("---------------------------------------");
						debug(" nom    : 'ING" & String_buffer(23) & "'");
						debug(" statut : '" & String_buffer(27..36) & "'");
						debug(" annee  : '" & string_buffer(16..19) & "'");
						debug("---------------------------------------");	
						prom.nom := "ING" & String_buffer(23);
						prom.statut := String_buffer(27..36);
						prom.annee := integer'value( string_buffer(16..19) );
						addPromo(p_student.all.promos,prom);
					end create_promo;
				end if;
			end update_promo;

			string_buffer := (others => ' ');
		end loop;
		close(buffer);

		debug("infos modules");
		---------------------------INFO MODULES-----------------------------------------

		open(buffer, in_file, "notes2004-2008.txt");

		set_line(buffer, 3);
		while not end_of_file(buffer) and line(buffer) < 41939 loop
			get_line(buffer, string_buffer, n);
			
			update_Module:declare
				id_buffer    : integer;
				annee_buffer : year_number;
				p_student    : liste_etudiant;
				p_promo      : liste_promo;
			begin
				id_buffer := integer'value(string_buffer(1..8));
				p_student := get_student(etudiants,id_buffer);
				if p_student /= null then
					debug("Etudiant repere : " & integer'image(p_student.all.id));
					annee_buffer := integer'value( string_buffer(16..19) );
					p_promo := get_promo(p_student.all.promos, annee_buffer);
					if p_promo /= null then	
						debug("Promo repere : " & integer'image(p_promo.all.annee));
						create_Module:declare
							mat : module;
						begin
							debug("---------------------------------------");
							debug(" nom  : '" & string_buffer(32..61) & "'");
							debug(" note : '" & string_buffer(21..30) & "'");
							debug(" dept : '" & string_buffer(63..69) & "'");
							debug("---------------------------------------");		
							mat.nom := string_buffer(32..61);
							mat.note := compute_float_value( string_buffer(21..30) );
							mat.departement := string_buffer(63..69);
							addModule(p_promo.all.matieres,mat);
						end create_module;
					end if;
				end if;
			end update_module;

			string_buffer := (others => ' ');
		end loop;
		close(buffer);

		debug("Test liste ");
		if debug_mode then
			afficher(etudiants);
		end if;

	end get_students;

end p_file;
