-------------------------------------------------------
--     PACKAGE POUR OPERATIONS SUR UN FICHIER        -- 
-------------------------------------------------------
WITH Ada.Text_IO; USE Ada.Text_IO;
with ada.calendar; use ada.calendar;
with etude; use etude;
with aleatoire; use aleatoire;

PACKAGE P_File IS

	type ligne;
	type liste_ligne is access ligne;

	--Ligne
	type ligne is record
		numero : integer;
		next : liste_ligne;
	end record;

	---------------FONCTION LISTE LIGNE----------------------------------

	--affiche le contenu d'une liste
	procedure afficher(liste : in liste_ligne);

	--compte le nb_d'element
	function count(liste : liste_ligne) return integer;

	--ajoute un element tri
	procedure sortedAppend(liste : in out liste_ligne; element : in integer);

	--Recupere l'element suivant et le retire de la liste ( Agit comme le pop dune file)
	procedure get_next(file : in out liste_ligne; element : out integer);

	--Corrige les valeurs de la liste pour qu'elles correspondent au dcalage du fichier
	procedure ajust_lignes(liste : in out liste_ligne);

	--transforme un tableau en liste (Compatibilit avec le tableau qui vient du package ALEATOIRE)
	function array_to_queue( t : t_integer) return liste_ligne;

	---------------FONCTION FICHIER----------------------------------
	
	--Extrait la donne rel d'un string qui reprsente un float avec une virgule au lieu d'un point
	function compute_float_value(text : string) return float;

	--recupere une liste d'tudiant depuis les fichiers donnes en selectionnant les lignes contenus dans la liste
	procedure get_students(lignes : in liste_ligne; etudiants : out liste_etudiant);

	---------------CONSTANTES----------------------------------

	--nombre de ligne a sauter pour se mettre sur le premier etudiant
	OFFSET : constant integer := 2;

END P_File;
