with p_file; use p_file;
with etude; use etude;
with fctuniquant; use fctuniquant;
with fctuniqual; use fctuniqual;
with aleatoire; use aleatoire;
with ada.text_io; use ada.text_io;
with ada.integer_text_io; use ada.integer_text_io;

procedure test_univarie_etudiant is

	--choix menu
	type caract_stat is (qualite,quantite);
	package caract_stat_io is new enumeration_io(caract_stat); use caract_stat_io;

   --Fonctions banale
   function menu return mode_quantitatif is
   	caractere : mode_quantitatif;
   begin
   		put_line("Choisissez le mode de caractere a etudier :");
		for i in mode_quantitatif'first..mode_quantitatif'last loop
			put_line(" - " & mode_quantitatif'image(i));
		end loop;
		Mode_Quant_io.get(caractere);
		skip_line;
		return caractere;
	end menu;

   function menu return mode_qualitatif is
   	caractere : mode_qualitatif;
   begin
   		put_line("Choisissez le mode de caractere a etudier :");
		for i in mode_qualitatif'first..mode_qualitatif'last loop
			put_line(" - " & mode_qualitatif'image(i));
		end loop;
		Mode_Qual_io.get(caractere);
		skip_line;
		return caractere;
	end menu;

	function menu return caract_stat is
		type_caract : caract_stat;
	begin
   		put_line("Choisissez le type de caractere a etudier :");
		for i in caract_stat'first..caract_stat'last loop
			put_line(" - " & caract_stat'image(i));
		end loop;
		caract_stat_io.get(type_caract);
		skip_line;
		return type_caract;
	end menu;

	choix : caract_stat;

	lignes : liste_ligne;
	etudiants : liste_etudiant;
	taille_echantillonage : natural range natural'first..Etude.last_etudiant;
	
begin
	
	put("Saisissez la taille de l'echantillonnage : ");
	get(taille_echantillonage); skip_line;
	declare
		tableau : t_integer(1..taille_echantillonage);
	begin
	   put_line("Generation des donnees sur l'echantillonnage...");
	   tableau := EchantillonAleatoire(1,last_etudiant,tableau'last);
	   lignes := array_to_queue(tableau);
   end;
--   afficher(lignes);
   delay(0.1);
   put_line("Recuperation des etudiants...");
   get_students(lignes,etudiants);
--   afficher(etudiants);
   delay(0.1);

   choix := menu;

   case choix is
   		when qualite =>
			traitement_qualite:declare
				--DEBUT declaration des besoins pour un test d'analyse quantitative
				Analyse_qualite : ANA_QUAL;
				Res              : RES_ANA_QUAL;
			begin
				put_line("Recuperation des donnees sur les etudiants...");
				get_caractere(etudiants, menu, analyse_qualite); --appel implicite de la fonction menu sur qulite
				delay(0.1);
				put_line("Calcul statistiques...");
				res := TraitementQualitatifUnivarie(analyse_qualite);
				delay(0.1);new_line;
				put_line("Resultat !");
				afficher(res);
			end traitement_qualite;
		when quantite =>
			traitement_quantite:declare
				--DEBUT declaration des besoins pour un test d'analyse quantitative
				Analyse_quantite : ANA_QUANT;
				Res              : RES_ANA_QUANT;
			begin
				put_line("Recuperation des donnees sur les etudiants...");
				get_caractere(etudiants, menu, analyse_quantite); --appel implicite de la fonction menu sur qulite
				delay(0.1);
				put_line("Calcul statistiques...");
				res := TraitementQuantitatifUnivarie(analyse_quantite);
				delay(0.1);new_line;
				put_line("Resultat !");
				afficher(res);
			end traitement_quantite;
   end case;
   
end test_univarie_etudiant;
